<?php
/*	trash box plugin
	author: team1/3
	
*/

	if (!isset($config)) { die(); }
	global $html,$params,$ut;
	$html['article'][] = "<p style='background-color: #ffdada;padding:20px;'>This page is currently in the trash.  <a href='{$ut->link("trash?id={$params['page']['id']}")}&amp;act=recover' class='onethird-button mini'>recover</a> </p>";

function trash_page(&$page_ar)
{
	global $html,$params,$database,$ut;
	
	$id = 0;
	
	if (!check_rights('edit')) {
		return;
	}
	
	$html['article'] = array();
	
$html['css']['trash_page'] = <<<EOT
	<style>
		.trash_panel {
			background-color: #e8d6c3;
			padding: 20px;
			margin-bottom: 35px;
			border-radius: 7px;
		}
	</style>
EOT;

	$buff = '';
	$id = false;
	if (isset($_GET['id'])) {
		$id = (int)$_GET['id'];
		if( $id == $params['circle']['meta']['top_page']) {
			$id = false;
		}
	}
	if ($id) {
		if (read_pagedata($id, $page_ar)) {
			if (!isset($page_ar['meta']['trash'])) {
				$link_ar = array();
				get_linked_pages( $page_ar['id'], $link_ar );
				$c = count($link_ar);
$buff .= <<<EOT
				<div class='trash_panel'>
					<p>
						#{$page_ar['id']} {$page_ar['title']}
					</p>
EOT;
					if ($c >1) {
$buff .= <<<EOT
						<p>
							Are you sure you want to move those pages ({$c}) to trash box? 
							<input type='button' value='trash' class='onethird-button mini' onclick='move_trash()' />
						</p>
EOT;
					} else {
$buff .= <<<EOT
						<p>
							Are you sure you want to move this page #{$page_ar['id']} to trash box? 
							<input type='button' value='trash' class='onethird-button mini' onclick='move_trash()' />
						</p>
EOT;
					}
$buff .= <<<EOT
					<p>
						<a href='{$ut->link("trash")}'>trash box</a> 
					</p>
				</div>
EOT;
				$html['article'][] = $buff;
				$html['article'][] = basic_renderer($id);
			}

			if (isset($_POST['ajax']) && $_POST['ajax'] == 'move_trash')  {
				$r = array();
				$r['id'] = $id;
				function move_trash_one($id,$type,$child_c) {
					global $html,$params,$database,$ut;
					$page_ar = array();
					if (read_pagedata_raw($id, $page_ar)) {
						if ($page_ar['block_type']!=5) {
							$page_ar['meta']['trash']['trash_date'] = $params['now'];
							$page_ar['meta']['trash']['mod_date'] = $page_ar['mod_date'];
							$page_ar['mod_date'] = $params['now'];
							$page_ar['meta']['trash']['block_type'] = $page_ar['block_type'];
							$page_ar['meta']['trash']['child'] = $child_c;
							if ($database->sql_update("update ".DBX."data_items set block_type=? where id=?", $type, $id)) {
								// block_typeはmod_data_itemsで変更できない
									if (isset($page_ar['meta']['template_ar']['php'])) {
									$page_ar['meta']['trash']['template_ar'] = $page_ar['meta']['template_ar'];
									if (is_array($page_ar['meta']['template_ar']['php'])) {
										array_unshift($page_ar['meta']['template_ar']['php'],'.trash.php');
									} else {
										$page_ar['meta']['template_ar']['php'] = array('.trash.php',$page_ar['meta']['template_ar']['php']);
									}
								} else {
									$page_ar['meta']['template_ar']['php'] = '.trash.php';
								}
								if (mod_data_items($page_ar)) {
									return true;
								}
							}
						}
					}
					return false;
				}
				$r['result'] = false;
				if (move_trash_one($id,30,$c)) {
					foreach ($link_ar as $v) {
						if ($id != $v) {
							move_trash_one($v,31,0);
						}
					}
					$r['result'] = true;
				}
				echo( json_encode($r) );
				exit();
			}

			if (!isset($html['meta']['move_trash'])) {
$html['meta']['move_trash'] = <<<EOT
				<script>
					function move_trash() {
						ot.ajax({
							type: "POST"
							, url: '{$params['safe_request']}'
							, data: "ajax=move_trash"
							, dataType:'json'
							, success: function(data){
								if ( data && data['result'] ) {
									location.href='{$ut->link('trash')}';
								} else {
									alert('Error');
								}
							}
						});
					};
				</script>
EOT;
				if (!isset($page_ar['meta']['trash'])) {
					return;
				}
			}
		}
	}

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'trash_recover_page')  {
		$r = array();
		$id = $r['id'] = (int)$_POST['page'];
		function move_recover_one($id,$type) {
			global $html,$params,$database,$ut;
			$page_ar = array();
			if (read_pagedata_raw($id, $page_ar)) {
				if (isset($page_ar['meta']['trash']['block_type']) && $page_ar['block_type'] == $type) {
					if ($database->sql_update("update ".DBX."data_items set block_type=? where id=?", $page_ar['meta']['trash']['block_type'], $id)) {
						if (isset($page_ar['meta']['trash']['link'])) {
							$page_ar['link'] = $page_ar['meta']['trash']['link'];
						}
						if (isset($page_ar['meta']['trash']['template_ar'])) {
							$page_ar['meta']['template_ar'] = $page_ar['meta']['trash']['template_ar'];
						} else {
							unset($page_ar['meta']['template_ar']);
						}
						unset($page_ar['meta']['trash']);
						$page_ar['metadata'] = serialize64($page_ar['meta']);
						if (mod_data_items($page_ar)) {
							return true;
						}
					}
				}
			}
			return false;
		}
		if (move_recover_one($id,30)) {
			$link_ar = array();
			get_linked_pages( $id, $link_ar );
			foreach ($link_ar as $v) {
				if ($id != $v) {
					move_recover_one($v,31);
				}
			}
			$r['result'] = true;
		}
		echo( json_encode($r) );
		exit();
	}

	$params['breadcrumb'] = array();
	if ($page_ar['id']) {
		$params['breadcrumb'][] = array('link'=>$page_ar['id'], 'text'=>$page_ar['title']);
	}
	$params['breadcrumb'][] = array('link'=>'trash', 'text'=>'trash box v1.95');
	
	if (isset($_GET['act']) && $_GET['act']=='recover') {
$buff .= <<<EOT
		<p style='background-color: #ffdada;padding:20px;'>
			<input type='button' value='Recover this page?' onclick='trash_recover()' class='onethird-button mini recover' />
		</p>
EOT;
		$html['article'][] = $buff;

		$html['article'][] = basic_renderer($page_ar['id']);

$html['meta']['trash'] = <<<EOT
		<script>
		function trash_recover() {
			ot.ajax({
				type: "POST"
				, url: '{$params['safe_request']}'
				, data: "ajax=trash_recover_page&page={$page_ar['id']}"
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						location.href='{$ut->link($page_ar['id'])}';
					} else {
						alert('Error');
					}
				}
			});
		};
		</script>
EOT;

		return;
	}

	$option = array();
	$option['total'] = 0;
	if (isset($_GET['offset'])) {
		$option['offset'] = (int)$_GET['offset'];
	} else {
		$option['offset'] = 0;
	}
	$option['page_size'] = 100;
	$option['offset_name'] = 'offset';
	$option['url'] = $params['request'];

	$sql = array();
	$sql[0] = "select count(id) as c from ".DBX."data_items ";
	$sql[1] = array(" where block_type =30");

	// count
	$ar = $database->sql_select_all($sql);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	} else {
		$option['total'] = 0;
	}

	// page
	$sql[0] = "select id,type,metadata,title,mode,user,date,mod_date,pv_count from ".DBX."data_items ";
	$sql[2]  = array(" order by date ");
	if (isset($_GET['order_date'])) {
		if ($_GET['order_date']==1) {
			$sql[2]  = array(" order by date ");
		} else {
			$sql[2]  = array(" order by date desc");
		}
	}
	if (isset($_GET['order_pv'])) {
		if ($_GET['order_pv']==1) {
			$sql[2]  = array(" order by pv_count ");
		} else {
			$sql[2]  = array(" order by pv_count desc");
		}
	}
	$sql[]  = array(" {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ");
	
	$ar = $database->sql_select_all($sql);
	
	if (!$ar) {
		$html['article'][] = "<p>No items</p>";
	} else {
		// 一覧表示
		$buff = '';
		$buff .= std_pagination_renderer( $option ).$buff;
		
		$buff .= "<p>{$option['total']} items</p>";
		$u = $params['request_name'];
		$buff .= "<p> [<a href='$u'>id</a>] [<a href='$u?order_date=1'>date ↑</a>] [<a href='$u?order_date=0'>date ↓</a>] [<a href='$u?order_pv=1'>pv ↑</a>] [<a href='$u?order_pv=0'>pv ↓</a>] </p>";

		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			$d = substr($v['date'],0,10);
			$d .= ' ('.substr($v['mod_date'],5,5).') ';
			if (!empty($m['trash']['child']) && $m['trash']['child']>1) {
				$c = "({$m['trash']['child']})";
			} else {
				$c = '';
			}
$buff .= <<<EOT
			<p id='trash_{$v['id']}'> #{$v['id']} 
				<a href='#' onclick='trash_remove_page({$v['id']})' >{$ut->icon('delete')}</a>
				$d <a href='{$ut->link($v['id'])}'>{$v['title']}</a> $c [{$v['pv_count']}]
				<input type='button' value='recover' onclick='trash_recover_page({$v['id']})' class='onethird-button mini recover' />
			</p>
EOT;
		}
		$html['article'][] = $buff;
}

$html['meta']['trash'] = <<<EOT
	<script>
	function trash_remove_page(id) {
		if (confirm("do you want execute?")) {
			ot.ajax({
				type: "POST"
				, url: '{$params['safe_request']}'
				, data: "ajax=remove_page&page="+id
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						\$('#trash_'+data['page']).hide();
					} else {
						alert('Error');
					}
				}
			});
		}
	};
	function trash_recover_page(page_id) {
		ot.ajax({
			type: "POST"
			, url: '{$params['safe_request']}'
			, data: "ajax=trash_recover_page&page="+page_id
			, dataType:'json'
			, success: function(data){
				if ( data && data['result'] ) {
					\$('#trash_'+data['id']+' .recover').hide().after('recovered!');
				} else {
					alert('Error');
				}
			}
		});
	};
	</script>
EOT;

}


?>